<template>
  <v-dialog
    v-model="dialogDiagram"
    fullscreen
    hide-overlay
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar dark color="#1A67C0">
        <v-btn icon dark @click="close()">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>ออกแบบผังตู้</v-toolbar-title>
        <v-toolbar-title
          ><v-chip
            class="ma-2"
            color="orange"
            label
            outlined
            v-if="
              obj.status === 'RP' || obj.status === 'RD' || obj.status === 'RF'
            "
          >
            เหตุผล:
            {{ obj.remark }}
          </v-chip></v-toolbar-title
        >
        <v-spacer></v-spacer>
        <v-toolbar-items>
          <v-btn
            dark
            text
            :disabled="loading"
            :loading="loading"
            @click="save"
            v-if="(obj.status == 'RD' || obj.status == 'WD') && role == 'Admin'"
          >
            บันทึก
          </v-btn>
          <v-btn
            dark
            text
            @click="confirm('approveDPartner')"
            v-if="obj.status == 'VD' && role == 'Partner'"
          >
            อนุมัติ
          </v-btn>
          <v-btn
            dark
            text
            @click="confirm('rejectDPartner')"
            v-if="obj.status == 'VD' && role == 'Partner'"
          >
            ส่งกลับเพื่อแก้ไขข้อมูล
          </v-btn>
        </v-toolbar-items>
      </v-toolbar>
      <v-overlay :value="overlay">
        <div class="text-center">
          <v-progress-circular
            :size="70"
            :width="7"
            color="amber"
            indeterminate
          >
          </v-progress-circular>
        </div>
      </v-overlay>
      <div
        align="center"
        v-if="(obj.status == 'RD' || obj.status == 'WD') && role == 'Admin'"
      >
        <dashboard :id="'dashExample'">
          <dash-layout
            v-for="layout in dlayouts"
            v-bind="layout"
            :debug="false"
            :key="layout.breakpoint"
            :compact="false"
          >
            <dash-item
              v-for="item in layout.items"
              v-bind="item"
              :key="item.id"
              @moveEnd="moveEnd"
              @hoverStart="hoverStart"
              @moveStart="moveStart"
              :resizable="false"
              :locked="item.locked"
            >
              <div class="content">{{ item.id }}</div>
            </dash-item>
          </dash-layout>
        </dashboard>
      </div>
      <div align="center" v-else>
        <dashboard :id="'dashExample'">
          <dash-layout
            v-for="layout in dlayouts"
            v-bind="layout"
            :debug="false"
            :key="layout.breakpoint"
          >
            <dash-item
              v-for="item in layout.items"
              v-bind="item"
              :key="item.id"
              :draggable="false"
              :resizable="false"
            >
              <div class="contentNon">{{ item.id }}</div>
            </dash-item>
          </dash-layout>
        </dashboard>
      </div>
    </v-card>
  </v-dialog>
</template>

<script>
import { Dashboard, DashLayout, DashItem } from "vue-responsive-dash";

export default {
  components: {
    Dashboard,
    DashLayout,
    DashItem,
  },
  props: ["obj", "dialogDiagram","overlay","dlayouts"],

  data() {
    return {
      canUnLock: true,
      // overlay: false,
      loading: false,
      role: this.$store.getters["auth/roleUser"],
      // dlayouts: [
      //   {
      //     breakpoint: "lg",
      //     breakpointWidth: 1200,
      //     numberOfCols: 8,
      //     items: [],
      //   },
      // ],
    };
  },
  methods: {
    close() {
      this.$emit('update:close', false)
    },
    // async openDiagram(item) {
    //   this.overlay = true;
    //   if (
    //     this.obj.status == "RD" ||
    //     this.obj.status == "VD" ||
    //     this.obj.status == "WP" ||
    //     this.obj.status == "VP" ||
    //     this.obj.status == "WA" ||
    //     this.obj.status == "A"
    //   ) {
    //     await this.$store.dispatch("locker/getDiagram", item.lockerId);
    //     let diagram = this.$store.getters["locker/lockerDiagram"];
    //     this.dlayouts[0].items = [];
    //     setTimeout(() => {
    //       for (let i in diagram) {
    //         let roomCode = diagram[i].lkRoomCode.substring(0, 1);
    //         let item;
    //         if (roomCode === "S") {
    //           item = {
    //             id: `${diagram[i].lkRoomCode}`,
    //             x: parseInt(diagram[i].columnPosition),
    //             y: parseInt(diagram[i].rowPosition),
    //             width: 1,
    //             height: 1,
    //             lkRoomId: diagram[i].lkRoomId,
    //             locked: false,
    //           };
    //         }
    //         if (roomCode === "M") {
    //           item = {
    //             id: `${diagram[i].lkRoomCode}`,
    //             x: parseInt(diagram[i].columnPosition),
    //             y: parseInt(diagram[i].rowPosition),
    //             width: 1,
    //             height: 2,
    //             lkRoomId: diagram[i].lkRoomId,
    //             locked: false,
    //           };
    //         }
    //         if (roomCode === "L") {
    //           item = {
    //             id: `${diagram[i].lkRoomCode}`,
    //             x: parseInt(diagram[i].columnPosition),
    //             y: parseInt(diagram[i].rowPosition),
    //             width: 1,
    //             height: 3,
    //             lkRoomId: diagram[i].lkRoomId,
    //             locked: false,
    //           };
    //         }
    //         this.dlayouts[0].items.push(item);
    //       }
    //       this.overlay = false;
    //     }, 2000);
    //   } else if (this.obj.status == "WD" || this.obj.status == "VF") {
    //     this.dlayouts[0].items = [];

    //     setTimeout(() => {
    //       for (let j = 0; j < this.obj.sAmount; j++) {
    //         let count = parseInt(j) + 1;
    //         let number = j < 10 ? `0${count}` : count;
    //         let item = {
    //           id: `S${number}`,
    //           x: j,
    //           y: 0,
    //           width: 1,
    //           height: 1,
    //           locked: false,
    //         };
    //         this.dlayouts[0].items.push(item);
    //       }
    //       for (let j = 0; j < this.obj.mAmount; j++) {
    //         let count = parseInt(j) + 1;
    //         let number = j < 10 ? `0${count}` : count;
    //         let item = {
    //           id: `M${number}`,
    //           x: j,
    //           y: 1,
    //           width: 1,
    //           height: 2,
    //           locked: false,
    //         };
    //         this.dlayouts[0].items.push(item);
    //       }
    //       for (let j = 0; j < this.obj.lAmount; j++) {
    //         let count = parseInt(j) + 1;
    //         let number = j < 10 ? `0${count}` : count;
    //         let item = {
    //           id: `L${number}`,
    //           x: j,
    //           y: 2,
    //           width: 1,
    //           height: 3,
    //           locked: false,
    //         };
    //         this.dlayouts[0].items.push(item);
    //       }
    //     }, 2000);
    //     this.overlay = false;
    //   }
    //   for (let i in this.dlayouts[0].items) {
    //     this.dlayouts[0].items[i].locked = true;
    //   }
    // },
    confirm(i) {
      this.$emit("click", i);
    },
    hoverStart(position) {
      for (let i in this.dlayouts[0].items) {
        if (position.id == this.dlayouts[0].items[i].id && this.canUnLock) {
          this.dlayouts[0].items[i].locked = false;
        }
      }
    },
    moveStart(position) {
      this.canUnLock = false;
      for (let i in this.dlayouts[0].items) {
        if (position.id !== this.dlayouts[0].items[i].id) {
          this.dlayouts[0].items[i].locked = true;
        }
      }
    },
    moveEnd(position) {
      for (let i in this.dlayouts[0].items) {
        if (position.id == this.dlayouts[0].items[i].id) {
          this.dlayouts[0].items[i].x = position.x;
          this.dlayouts[0].items[i].y = position.y;
          this.canUnLock = true;
          this.dlayouts[0].items[i].locked = true;
        }
      }
    },
    async save() {
      this.loading = true;
      await this.$store.dispatch("locker/getLockerSize");
      let error = this.$store.getters["locker/error"];
      let lockerSize = this.$store.getters["locker/lockerSize"];
      let dataDiagram = { formId: this.obj.formId, LockerRoomList: [] };
      if (error == false) {
        for (let i in lockerSize) {
          for (let j in this.dlayouts[0].items) {
            if (
              lockerSize[i].lkSizeName ==
              this.dlayouts[0].items[j].id.substring(0, 1)
            ) {
              let data = {
                LkSizeId: lockerSize[i].lkSizeId,
                LkRoomId: this.dlayouts[0].items[j].lkRoomId,
                ColumnPosition: this.dlayouts[0].items[j].x,
                RowPosition: this.dlayouts[0].items[j].y,
              };
              dataDiagram.LockerRoomList.push(data);
            }
          }
        }
        await this.$store.dispatch("locker/createDiagram", dataDiagram);
        let error = this.$store.getters["locker/error"];
        if (error == false) {
          await this.$store.dispatch("snackbar/showSnack", {
            text: "ดำเนินการสำเร็จ",
            color: "success",
            timeout: 3000,
          });
          this.loading = false;
          this.$emit("update:close", false);
          this.$emit("closedialog", false);
          this.$emit("updateTable", true);
        } else {
          await this.$store.dispatch("snackbar/showSnack", {
            text: "ข้อมูลจากระบบผิดพลาด",
            color: "red",
            timeout: 3000,
          });
          this.loading = false;
          this.$emit("update-table", true);
        }
      }
    },
  },
};
</script>

<style>
.content {
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  color: #fff;
  justify-content: center;
  border: 2px solid #42b983;
  border-radius: 5px;
  background-color: #d6efe1;
}
.contentNon {
  height: 100%;
  width: 100%;
  cursor: not-allowed;
  display: flex;
  align-items: center;
  color: #fff;
  justify-content: center;
  border: 2px solid #42b983;
  border-radius: 5px;
  background-color: #d6efe1;
}
</style>